/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180105 (64-bit version)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt3.dat, Mon Mar 18 13:49:24 2024
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001359 (4953)
 *     Revision         0x02
 *     Checksum         0xBB
 *     OEM ID           "DELL  "
 *     OEM Table ID     "PE_SC3  "
 *     OEM Revision     0x00000002 (2)
 *     Compiler ID      "DELL"
 *     Compiler Version 0x00000001 (1)
 */
DefinitionBlock ("", "SSDT", 2, "DELL  ", "PE_SC3  ", 0x00000002)
{
    /*
     * iASL Warning: There were 3 external control methods found during
     * disassembly, but only 0 were resolved (3 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.NVDM, IntObj)
    External (_SB_.PC00, DeviceObj)
    External (_SB_.PC00.D011, DeviceObj)
    External (_SB_.PC00.D071, DeviceObj)
    External (_SB_.PC01, DeviceObj)
    External (_SB_.PC01.D011, DeviceObj)
    External (_SB_.PC01.D012, DeviceObj)
    External (_SB_.PC01.D071, DeviceObj)
    External (_SB_.PC02, DeviceObj)
    External (_SB_.PC02.D011, DeviceObj)
    External (_SB_.PC02.D012, DeviceObj)
    External (_SB_.PC02.D013, DeviceObj)
    External (_SB_.PC02.D014, DeviceObj)
    External (_SB_.PC02.D071, DeviceObj)
    External (_SB_.PC03, DeviceObj)
    External (_SB_.PC03.D011, DeviceObj)
    External (_SB_.PC03.D052, DeviceObj)
    External (_SB_.PC03.D053, DeviceObj)
    External (_SB_.PC03.D071, DeviceObj)
    External (_SB_.PC03.D072, DeviceObj)
    External (_SB_.PC04, DeviceObj)
    External (_SB_.PC04.D011, DeviceObj)
    External (_SB_.PC04.D012, DeviceObj)
    External (_SB_.PC04.D071, DeviceObj)
    External (_SB_.PC05, DeviceObj)
    External (_SB_.PC05.D011, DeviceObj)
    External (_SB_.PC05.D071, DeviceObj)
    External (_SB_.PC06, DeviceObj)
    External (_SB_.PC06.D011, DeviceObj)
    External (_SB_.PC06.D012, DeviceObj)
    External (_SB_.PC06.D013, DeviceObj)
    External (_SB_.PC06.D014, DeviceObj)
    External (_SB_.PC06.D071, DeviceObj)
    External (_SB_.PC07, DeviceObj)
    External (_SB_.PC07.D011, DeviceObj)
    External (_SB_.PC07.D012, DeviceObj)
    External (_SB_.PC07.D071, DeviceObj)
    External (D011, DeviceObj)
    External (D012, DeviceObj)
    External (D013, DeviceObj)
    External (D014, DeviceObj)
    External (D052, DeviceObj)
    External (D053, DeviceObj)
    External (D071, DeviceObj)
    External (D072, DeviceObj)
    External (DDSM, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (DSMB, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (DSMP, MethodObj)    // Warning: Unknown method, guessing 4 arguments
    External (PC00, DeviceObj)
    External (PC01, DeviceObj)
    External (PC02, DeviceObj)
    External (PC03, DeviceObj)
    External (PC04, DeviceObj)
    External (PC05, DeviceObj)
    External (PC06, DeviceObj)
    External (PC07, DeviceObj)

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D053)
            {
                Device (D000)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [E111]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x206F, 
                                Unicode ("Embedded NIC 1")
                            })
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D053)
            {
                Device (D001)
                {
                    Name (_ADR, 0x00000001)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [E211]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x20D3, 
                                Unicode ("Embedded NIC 2")
                            })
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D011)
            {
                Name (_SUN, 0x03)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS03]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0003, 
                            Unicode ("SLOT 3")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC01)
        {
            Scope (D011)
            {
                Name (_SUN, 0x02)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS02]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0002, 
                            Unicode ("SLOT 2")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC01)
        {
            Scope (D012)
            {
                Name (_SUN, 0x01)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS01]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0001, 
                            Unicode ("SLOT 1")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC07)
        {
            Scope (D011)
            {
                Name (_SUN, 0x07)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS07]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0007, 
                            Unicode ("SLOT 7")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC07)
        {
            Scope (D012)
            {
                Name (_SUN, 0x08)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS08]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0008, 
                            Unicode ("SLOT 8")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC05)
        {
            Scope (D011)
            {
                Name (_SUN, 0x06)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS06]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0006, 
                            Unicode ("SLOT 6")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC04)
        {
            Scope (D011)
            {
                Name (_SUN, 0x05)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS05]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0005, 
                            Unicode ("SLOT 5")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC04)
        {
            Scope (D012)
            {
                Name (_SUN, 0x04)  // _SUN: Slot User Number
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Debug = "DAC DSM [PS04]"
                    DSMP (Arg0, Arg1, Arg2, Arg3)
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                        Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                    {
                        Return (Package (0x02)
                        {
                            0x0004, 
                            Unicode ("SLOT 4")
                        })
                    }

                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D011)
            {
                Device (N104)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N104]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A4, 
                                Unicode ("PCIe SSD in Slot 4 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x04
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D012)
            {
                Device (N105)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N105]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A5, 
                                Unicode ("PCIe SSD in Slot 5 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x05
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D013)
            {
                Device (N106)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N106]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A6, 
                                Unicode ("PCIe SSD in Slot 6 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x06
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D014)
            {
                Device (N107)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N107]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A7, 
                                Unicode ("PCIe SSD in Slot 7 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x07
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D011)
            {
                Device (N101)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N101]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A1, 
                                Unicode ("PCIe SSD in Slot 1 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x01
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D012)
            {
                Device (N100)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N100]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A0, 
                                Unicode ("PCIe SSD in Slot 0 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x00
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D013)
            {
                Device (N103)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N103]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A3, 
                                Unicode ("PCIe SSD in Slot 3 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x03
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D014)
            {
                Device (N102)
                {
                    Name (_ADR, 0x00000000)  // _ADR: Address
                    Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                    {
                        Debug = "DAC DSM [N102]"
                        DSMP (Arg0, Arg1, Arg2, Arg3)
                        Arg3 = DSMB (Arg0, Arg1, Arg2)
                        Local0
                        If ((((ToBuffer (Arg0) == ToUUID ("e5c937d0-3553-4d7a-9117-ea4d19c3434d") /* Device Labeling Interface */) && (ToInteger (
                            Arg1) >= 0x02)) && (ToInteger (Arg2) == 0x07)))
                        {
                            Return (Package (0x02)
                            {
                                0x00A2, 
                                Unicode ("PCIe SSD in Slot 2 Bay 1")
                            })
                        }

                        If ((ToBuffer (Arg0) == ToUUID ("5d524d9d-fff9-4d4b-8cb7-747ed51e194d")))
                        {
                            Return (\_SB.NVDM) /* External reference */
                            Arg0
                            Arg1
                            Arg2
                            Arg3
                            0x01
                            0x02
                        }

                        Return (Local0)
                    }
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC00)
        {
            Scope (D011)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC00)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC01)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D011)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D012)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D013)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D014)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D052)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D053)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D072)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC04)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC05)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D011)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D012)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D013)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D014)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC07)
        {
            Scope (D071)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    Arg3 = DDSM (Arg0, Arg1, Arg2)
                    Local0
                    Return (Local0)
                }
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC00)
        {
            Name (_PXM, 0x00000003)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC01)
        {
            Name (_PXM, 0x00000002)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Name (_PXM, 0x00000000)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Name (_PXM, 0x00000001)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC04)
        {
            Name (_PXM, 0x00000007)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC05)
        {
            Name (_PXM, 0x00000006)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Name (_PXM, 0x00000004)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC07)
        {
            Name (_PXM, 0x00000005)  // _PXM: Device Proximity
        }
    }

    Scope (\_SB)
    {
        Scope (PC00)
        {
            Scope (D011)
            {
                Name (_PXM, 0x00000003)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC00)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000003)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC01)
        {
            Scope (D012)
            {
                Name (_PXM, 0x00000002)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC01)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000002)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D011)
            {
                Name (_PXM, 0x00000000)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D012)
            {
                Name (_PXM, 0x00000000)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D013)
            {
                Name (_PXM, 0x00000000)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D014)
            {
                Name (_PXM, 0x00000000)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC02)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000000)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D052)
            {
                Name (_PXM, 0x00000001)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D053)
            {
                Name (_PXM, 0x00000001)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000001)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC03)
        {
            Scope (D072)
            {
                Name (_PXM, 0x00000001)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC04)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000007)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC05)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000006)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D011)
            {
                Name (_PXM, 0x00000004)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D012)
            {
                Name (_PXM, 0x00000004)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D013)
            {
                Name (_PXM, 0x00000004)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D014)
            {
                Name (_PXM, 0x00000004)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC06)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000004)  // _PXM: Device Proximity
            }
        }
    }

    Scope (\_SB)
    {
        Scope (PC07)
        {
            Scope (D071)
            {
                Name (_PXM, 0x00000005)  // _PXM: Device Proximity
            }
        }
    }
}

