/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180105 (64-bit version)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt5.dat, Mon Mar 18 13:49:24 2024
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000513 (1299)
 *     Revision         0x02
 *     Checksum         0x06
 *     OEM ID           "DELL  "
 *     OEM Table ID     "xhc_port"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20210331 (539034417)
 */
DefinitionBlock ("", "SSDT", 2, "DELL  ", "xhc_port", 0x00000001)
{
    External (_SB_.PC00.D071.D004, DeviceObj)
    External (_SB_.PC03.D071.D004, DeviceObj)

    Scope (\_SB)
    {
        Method (GPLD, 3, Serialized)
        {
            Name (PCKG, Package (0x01)
            {
                Buffer (0x10){}
            })
            CreateField (DerefOf (PCKG [0x00]), 0x00, 0x07, REV)
            REV = 0x01
            CreateField (DerefOf (PCKG [0x00]), 0x40, 0x01, VISI)
            VISI = Arg0
            CreateField (DerefOf (PCKG [0x00]), 0x43, 0x03, PANL)
            PANL = Arg1
            CreateField (DerefOf (PCKG [0x00]), 0x57, 0x08, GPOS)
            GPOS = Arg2
            Return (PCKG) /* \_SB_.GPLD.PCKG */
        }

        Method (GUPC, 1, Serialized)
        {
            Name (PCKG, Package (0x04)
            {
                0x00, 
                0xFF, 
                0x00, 
                0x00
            })
            PCKG [0x00] = Arg0
            Return (PCKG) /* \_SB_.GUPC.PCKG */
        }
    }

    Scope (\_SB.PC00.D071.D004)
    {
        Device (RHUB)
        {
            Name (_ADR, 0x00)  // _ADR: Address
            Device (HS01)
            {
                Name (_ADR, 0x01)  // _ADR: Address
            }

            Device (HS02)
            {
                Name (_ADR, 0x02)  // _ADR: Address
            }

            Device (SS01)
            {
                Name (_ADR, 0x03)  // _ADR: Address
            }

            Device (SS02)
            {
                Name (_ADR, 0x04)  // _ADR: Address
            }
        }
    }

    Scope (\_SB.PC03.D071.D004)
    {
        Device (RHUB)
        {
            Name (_ADR, 0x00)  // _ADR: Address
            Device (HS01)
            {
                Name (_ADR, 0x01)  // _ADR: Address
            }

            Device (HS02)
            {
                Name (_ADR, 0x02)  // _ADR: Address
            }

            Device (SS01)
            {
                Name (_ADR, 0x03)  // _ADR: Address
            }

            Device (SS02)
            {
                Name (_ADR, 0x04)  // _ADR: Address
            }
        }
    }

    Scope (\_SB.PC00.D071.D004.RHUB.HS01)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x01))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x00, 0x06, 0x06))
        }

        Device (HS01)
        {
            Name (_ADR, 0x01)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x01))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x01, 0x05, 0x03))
            }
        }

        Device (HS02)
        {
            Name (_ADR, 0x02)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x00))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x00, 0x00, 0x00))
            }
        }

        Device (HS03)
        {
            Name (_ADR, 0x03)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x01))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x01, 0x04, 0x01))
            }
        }

        Device (HS04)
        {
            Name (_ADR, 0x04)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x00))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x00, 0x00, 0x00))
            }
        }
    }

    Scope (\_SB.PC03.D071.D004.RHUB.HS01)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x01))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x00, 0x06, 0x05))
        }

        Device (HB01)
        {
            Name (_ADR, 0x01)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x01))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x00, 0x06, 0x05))
            }
        }

        Device (HB02)
        {
            Name (_ADR, 0x02)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x01))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x00, 0x06, 0x05))
            }
        }

        Device (HB03)
        {
            Name (_ADR, 0x03)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x01))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x00, 0x06, 0x05))
            }
        }

        Device (HB04)
        {
            Name (_ADR, 0x04)  // _ADR: Address
            Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
            {
                Return (GUPC (0x01))
            }

            Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
            {
                Return (GPLD (0x00, 0x06, 0x05))
            }
        }
    }

    Scope (\_SB.PC03.D071.D004.RHUB.HS02)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x01))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x01, 0x05, 0x02))
        }
    }

    Scope (\_SB.PC03.D071.D004.RHUB.SS02)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x01))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x01, 0x05, 0x02))
        }
    }

    Scope (\_SB.PC00.D071.D004.RHUB.HS02)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x01))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x00, 0x06, 0x04))
        }
    }

    Scope (\_SB.PC00.D071.D004.RHUB.SS02)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x01))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x00, 0x06, 0x04))
        }
    }

    Scope (\_SB.PC00.D071.D004.RHUB.SS01)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x00))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x00, 0x00, 0x00))
        }
    }

    Scope (\_SB.PC03.D071.D004.RHUB.SS01)
    {
        Method (_UPC, 0, NotSerialized)  // _UPC: USB Port Capabilities
        {
            Return (GUPC (0x00))
        }

        Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
        {
            Return (GPLD (0x00, 0x00, 0x00))
        }
    }
}

